Index: issm/trunk/src/c/kml/KML_Polygon.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_Polygon.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_Polygon.cpp	(revision 18301)
@@ -18,6 +18,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_Polygon::KML_Polygon(){{{*/
-KML_Polygon::KML_Polygon(){
+KML_Polygon::KML_Polygon(){/*{{{*/
 
 	extrude   =false;
@@ -30,6 +29,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Polygon::~KML_Polygon(){{{*/
-KML_Polygon::~KML_Polygon(){
+KML_Polygon::~KML_Polygon(){/*{{{*/
 
 	if (inner) {
@@ -47,6 +45,5 @@
 
 /*Other*/
-/*FUNCTION KML_Polygon::Echo {{{*/
-void  KML_Polygon::Echo(){
+void  KML_Polygon::Echo(){/*{{{*/
 
 	bool  flag=true;
@@ -64,6 +61,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Polygon::DeepEcho {{{*/
-void  KML_Polygon::DeepEcho(){
+void  KML_Polygon::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -74,6 +70,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Polygon::DeepEcho {{{*/
-void  KML_Polygon::DeepEcho(const char* indent){
+void  KML_Polygon::DeepEcho(const char* indent){/*{{{*/
 
 	int   i;
@@ -112,6 +107,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Polygon::Write {{{*/
-void  KML_Polygon::Write(FILE* filout,const char* indent){
+void  KML_Polygon::Write(FILE* filout,const char* indent){/*{{{*/
 
 	int   i;
@@ -152,6 +146,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Polygon::Read {{{*/
-void  KML_Polygon::Read(FILE* fid,char* kstr){
+void  KML_Polygon::Read(FILE* fid,char* kstr){/*{{{*/
 
 	char*        kstri;
@@ -259,6 +252,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Polygon::WriteExp {{{*/
-void  KML_Polygon::WriteExp(FILE* fid,const char* nstr,int sgn,double cm,double sp){
+void  KML_Polygon::WriteExp(FILE* fid,const char* nstr,int sgn,double cm,double sp){/*{{{*/
 
 	int   i;
Index: issm/trunk/src/c/kml/KML_Style.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_Style.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_Style.cpp	(revision 18301)
@@ -19,6 +19,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_Style::KML_Style(){{{*/
-KML_Style::KML_Style(){
+KML_Style::KML_Style(){/*{{{*/
 
 	icon      =NULL;
@@ -31,6 +30,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Style::~KML_Style(){{{*/
-KML_Style::~KML_Style(){
+KML_Style::~KML_Style(){/*{{{*/
 
 	if (list) {
@@ -63,6 +61,5 @@
 
 /*Other*/
-/*FUNCTION KML_Style::Echo {{{*/
-void  KML_Style::Echo(){
+void  KML_Style::Echo(){/*{{{*/
 
 	bool  flag=true;
@@ -81,6 +78,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Style::DeepEcho {{{*/
-void  KML_Style::DeepEcho(){
+void  KML_Style::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -91,6 +87,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Style::DeepEcho {{{*/
-void  KML_Style::DeepEcho(const char* indent){
+void  KML_Style::DeepEcho(const char* indent){/*{{{*/
 
 	char  indent2[81];
@@ -131,6 +126,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Style::Write {{{*/
-void  KML_Style::Write(FILE* filout,const char* indent){
+void  KML_Style::Write(FILE* filout,const char* indent){/*{{{*/
 
 	char  indent2[81];
@@ -165,6 +159,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Style::Read {{{*/
-void  KML_Style::Read(FILE* fid,char* kstr){
+void  KML_Style::Read(FILE* fid,char* kstr){/*{{{*/
 
 	char*        kstri;
Index: issm/trunk/src/c/kml/KML_StyleSelector.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_StyleSelector.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_StyleSelector.cpp	(revision 18301)
@@ -17,6 +17,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_StyleSelector::KML_StyleSelector(){{{*/
-KML_StyleSelector::KML_StyleSelector(){
+KML_StyleSelector::KML_StyleSelector(){/*{{{*/
 
 	;
@@ -24,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_StyleSelector::~KML_StyleSelector(){{{*/
-KML_StyleSelector::~KML_StyleSelector(){
+KML_StyleSelector::~KML_StyleSelector(){/*{{{*/
 
 	;
@@ -33,6 +31,5 @@
 
 /*Other*/
-/*FUNCTION KML_StyleSelector::Echo {{{*/
-void  KML_StyleSelector::Echo(){
+void  KML_StyleSelector::Echo(){/*{{{*/
 
 	KML_Object::Echo();
@@ -41,6 +38,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_StyleSelector::DeepEcho {{{*/
-void  KML_StyleSelector::DeepEcho(){
+void  KML_StyleSelector::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -51,6 +47,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_StyleSelector::DeepEcho {{{*/
-void  KML_StyleSelector::DeepEcho(const char* indent){
+void  KML_StyleSelector::DeepEcho(const char* indent){/*{{{*/
 
 	KML_Object::DeepEcho(indent);
@@ -59,6 +54,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_StyleSelector::Write {{{*/
-void  KML_StyleSelector::Write(FILE* filout,const char* indent){
+void  KML_StyleSelector::Write(FILE* filout,const char* indent){/*{{{*/
 
 	KML_Object::Write(filout,indent);
@@ -67,6 +61,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_StyleSelector::Read {{{*/
-void  KML_StyleSelector::Read(FILE* fid,char* kstr){
+void  KML_StyleSelector::Read(FILE* fid,char* kstr){/*{{{*/
 
 /*  process field within opening and closing tags  */
Index: issm/trunk/src/c/kml/KML_SubStyle.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_SubStyle.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_SubStyle.cpp	(revision 18301)
@@ -17,6 +17,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_SubStyle::KML_SubStyle(){{{*/
-KML_SubStyle::KML_SubStyle(){
+KML_SubStyle::KML_SubStyle(){/*{{{*/
 
 	;
@@ -24,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_SubStyle::~KML_SubStyle(){{{*/
-KML_SubStyle::~KML_SubStyle(){
+KML_SubStyle::~KML_SubStyle(){/*{{{*/
 
 	;
@@ -33,6 +31,5 @@
 
 /*Other*/
-/*FUNCTION KML_SubStyle::Echo {{{*/
-void  KML_SubStyle::Echo(){
+void  KML_SubStyle::Echo(){/*{{{*/
 
 	KML_Object::Echo();
@@ -41,6 +38,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_SubStyle::DeepEcho {{{*/
-void  KML_SubStyle::DeepEcho(){
+void  KML_SubStyle::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -51,6 +47,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_SubStyle::DeepEcho {{{*/
-void  KML_SubStyle::DeepEcho(const char* indent){
+void  KML_SubStyle::DeepEcho(const char* indent){/*{{{*/
 
 	KML_Object::DeepEcho(indent);
@@ -59,6 +54,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_SubStyle::Write {{{*/
-void  KML_SubStyle::Write(FILE* filout,const char* indent){
+void  KML_SubStyle::Write(FILE* filout,const char* indent){/*{{{*/
 
 	KML_Object::Write(filout,indent);
@@ -67,6 +61,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_SubStyle::Read {{{*/
-void  KML_SubStyle::Read(FILE* fid,char* kstr){
+void  KML_SubStyle::Read(FILE* fid,char* kstr){/*{{{*/
 
 /*  process field within opening and closing tags  */
Index: issm/trunk/src/c/kml/KML_Unknown.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_Unknown.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_Unknown.cpp	(revision 18301)
@@ -17,6 +17,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_Unknown::KML_Unknown(){{{*/
-KML_Unknown::KML_Unknown(){
+KML_Unknown::KML_Unknown(){/*{{{*/
 
 	name      =NULL;
@@ -25,6 +24,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Unknown::~KML_Unknown(){{{*/
-KML_Unknown::~KML_Unknown(){
+KML_Unknown::~KML_Unknown(){/*{{{*/
 
 	if (name      ) xDelete<char>(name);
@@ -35,6 +33,5 @@
 
 /*Other*/
-/*FUNCTION KML_Unknown::Echo {{{*/
-void  KML_Unknown::Echo(){
+void  KML_Unknown::Echo(){/*{{{*/
 
 	bool  flag=true;
@@ -53,6 +50,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Unknown::DeepEcho {{{*/
-void  KML_Unknown::DeepEcho(){
+void  KML_Unknown::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -63,6 +59,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Unknown::DeepEcho {{{*/
-void  KML_Unknown::DeepEcho(const char* indent){
+void  KML_Unknown::DeepEcho(const char* indent){/*{{{*/
 
 	char*        valuei;
@@ -93,6 +88,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Unknown::Write {{{*/
-void  KML_Unknown::Write(FILE* filout,const char* indent){
+void  KML_Unknown::Write(FILE* filout,const char* indent){/*{{{*/
 
 	char*        valuei;
@@ -125,6 +119,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Unknown::Read {{{*/
-void  KML_Unknown::Read(FILE* fid,char* kstr){
+void  KML_Unknown::Read(FILE* fid,char* kstr){/*{{{*/
 
 	char*        kstri;
Index: issm/trunk/src/c/main/issm.cpp
===================================================================
--- issm/trunk/src/c/main/issm.cpp	(revision 18081)
+++ issm/trunk/src/c/main/issm.cpp	(revision 18301)
@@ -23,4 +23,7 @@
 
 	/*Wrap up: */
+	femmodel->CleanUp();
+
+	/*Delete Model: */
 	delete femmodel;
 
Index: issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.h
===================================================================
--- issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.h	(revision 18081)
+++ issm/trunk/src/c/modules/ControlInputSetGradientx/ControlInputSetGradientx.h	(revision 18301)
@@ -7,5 +7,5 @@
 #include "../../classes/classes.h"
 
-void	ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,double* gradient);
+void	ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,IssmDouble* gradient);
 void	ControlInputSetGradientx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector<IssmDouble>* gradient);
 
Index: issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.cpp
===================================================================
--- issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.cpp	(revision 18301)
+++ issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.cpp	(revision 18301)
@@ -0,0 +1,39 @@
+/*!\file FloatingiceMeltingRatex
+ * \brief: calculates Floating ice melting rate
+ */
+
+#include "./FloatingiceMeltingRatex.h"
+#include "../../shared/shared.h"
+#include "../../toolkits/toolkits.h"
+
+void FloatingiceMeltingRatex(FemModel* femmodel){/*{{{*/
+
+	/*Intermediaties*/
+	int  basalforcing_model;
+
+	/*First, get SMB model from parameters*/
+	femmodel->parameters->FindParam(&basalforcing_model,BasalforcingsEnum);
+
+	/*branch to correct module*/
+	switch(basalforcing_model){
+		case FloatingMeltRateEnum:
+			/*Nothing to be done*/
+			break;
+		case LinearFloatingMeltRateEnum:
+			if(VerboseSolution())_printf_("	call Linear Floating melting rate module\n");
+			LinearFloatingiceMeltingRatex(femmodel);
+			break;
+		default:
+			_error_("Basal forcing model "<<EnumToStringx(basalforcing_model)<<" not supported yet");
+	}
+
+}/*}}}*/
+
+void LinearFloatingiceMeltingRatex(FemModel* femmodel){/*{{{*/
+
+	for(int i=0;i<femmodel->elements->Size();i++){
+		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+		element->LinearFloatingiceMeltingRate();
+	}
+
+}/*}}}*/
Index: issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.h
===================================================================
--- issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.h	(revision 18301)
+++ issm/trunk/src/c/modules/FloatingiceMeltingRatex/FloatingiceMeltingRatex.h	(revision 18301)
@@ -0,0 +1,14 @@
+/*!\file:  FloatingiceMeltingRatex.h
+ * \brief header file for Floatingice melting rate
+ */ 
+
+#ifndef _FloatingiceMeltingRatex_H
+#define _FloatingiceMeltingRatex_H
+
+#include "../../classes/classes.h"
+
+/* local prototypes: */
+void FloatingiceMeltingRatex(FemModel* femmodel);
+void LinearFloatingiceMeltingRatex(FemModel* femmodel);
+
+#endif  /* _FloatingiceMeltingRatex_H*/
Index: issm/trunk/src/c/modules/Gradjx/Gradjx.cpp
===================================================================
--- issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 18301)
@@ -9,6 +9,6 @@
 void Gradjx(Vector<IssmDouble>** pgradient,IssmDouble** pnorm_list, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters){
 
-	int     i,j,numberofvertices;
-	int     num_controls;
+	int          numberofvertices;
+	int          num_controls,analysisenum;
 	IssmDouble   norm_inf;
 	IssmDouble  *norm_list     = NULL;
@@ -17,4 +17,7 @@
 	Vector<IssmDouble> **gradient_list = NULL;
 
+	/*Display message*/
+	if(VerboseModule()) _printf0_("   Computing cost function gradient\n");
+
 	/*retrieve some parameters: */
 	parameters->FindParam(&num_controls,InversionNumControlParametersEnum);   _assert_(num_controls);
@@ -22,8 +25,12 @@
 	numberofvertices=vertices->NumberOfVertices();
 
+	/*Get current analysis*/
+	parameters->FindParam(&analysisenum,AnalysisTypeEnum);
+	Analysis* analysis = EnumToAnalysis(analysisenum);
+
 	/*Allocate gradient_list */
 	gradient_list = xNew<Vector<IssmDouble>*>(num_controls);
 	norm_list = xNew<IssmDouble>(num_controls);
-	for(i=0;i<num_controls;i++){
+	for(int i=0;i<num_controls;i++){
 		gradient_list[i]=new Vector<IssmDouble>(num_controls*numberofvertices);
 	}
@@ -31,19 +38,15 @@
 
 	/*Compute all gradient_list*/
-	for(i=0;i<num_controls;i++){
-
-		for(j=0;j<elements->Size();j++){
-
+	for(int i=0;i<num_controls;i++){
+		for(int j=0;j<elements->Size();j++){
 			Element* element=(Element*)elements->GetObjectByOffset(j);
-			element->Gradj(gradient_list[i],control_type[i],i);
+			analysis->GradientJ(gradient_list[i],element,control_type[i],i);
 		}
-
 		gradient_list[i]->Assemble();
-
 		norm_list[i]=gradient_list[i]->Norm(NORM_INF);
 	}
 
 	/*Add all gradient_list together*/
-	for(i=0;i<num_controls;i++){
+	for(int i=0;i<num_controls;i++){
 		gradient->AXPY(gradient_list[i],1.0);
 		delete gradient_list[i];
@@ -52,8 +55,11 @@
 	/*Check that gradient is clean*/
 	norm_inf=gradient->Norm(NORM_INF);
-	if(norm_inf<=0)    _error_("||∂J/∂α||∞ = 0    gradient norm is zero");
-	if(xIsNan<IssmDouble>(norm_inf))_error_("||∂J/∂α||∞ = NaN  gradient norm is NaN");
+	if(norm_inf<=0)                 _error_("||dJ/dk|| = 0    gradient norm is zero");
+	if(xIsNan<IssmDouble>(norm_inf))_error_("||dJ/dk|| = NaN  gradient norm is NaN");
 
 	/*Clean-up and assign output pointer*/
+	delete analysis;
+	xDelete<Vector<IssmDouble>*>(gradient_list);
+	xDelete<int>(control_type);
 	if(pnorm_list){
 		*pnorm_list=norm_list;
@@ -63,6 +69,5 @@
 	}
 	if(pgradient)  *pgradient=gradient;
-	xDelete<Vector<IssmDouble>*>(gradient_list);
-	xDelete<int>(control_type);
+
 }
 void Gradjx(IssmDouble** pgradient,IssmDouble** pnorm_list, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters){
Index: issm/trunk/src/c/modules/Gradjx/Gradjx.h
===================================================================
--- issm/trunk/src/c/modules/Gradjx/Gradjx.h	(revision 18081)
+++ issm/trunk/src/c/modules/Gradjx/Gradjx.h	(revision 18301)
@@ -7,4 +7,5 @@
 
 #include "../../classes/classes.h"
+#include "../../analyses/analyses.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp
===================================================================
--- issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 18301)
@@ -56,6 +56,5 @@
 }
 
-/*FUNCTION ContactFSLevelset{{{*/
-IssmDouble*    ContactFSLevelset(Elements* elements,Vertices* vertices){ 
+IssmDouble*    ContactFSLevelset(Elements* elements,Vertices* vertices){ /*{{{*/
 
 	Vector<IssmDouble>* vertexgrounded = NULL;
@@ -108,6 +107,5 @@
 }
 /*}}}*/
-/*FUNCTION PotentialUngrounding {{{*/
-IssmDouble*    PotentialUngrounding(Elements* elements,Vertices* vertices,Parameters* parameters){ 
+IssmDouble*    PotentialUngrounding(Elements* elements,Vertices* vertices,Parameters* parameters){ /*{{{*/
 
 	int                 i,numberofvertices;
@@ -135,6 +133,5 @@
 }
 /*}}}*/
-/*FUNCTION PropagateFloatingiceToGroundedNeighbors {{{*/
-IssmDouble*    PropagateFloatingiceToGroundedNeighbors(Elements* elements,Nodes* nodes,Vertices* vertices,Parameters* parameters,IssmDouble* vertices_potentially_ungrounding){ 
+IssmDouble*    PropagateFloatingiceToGroundedNeighbors(Elements* elements,Nodes* nodes,Vertices* vertices,Parameters* parameters,IssmDouble* vertices_potentially_ungrounding){ /*{{{*/
 	int                 i,analysis_type;
 	int                 nflipped,local_nflipped;
Index: issm/trunk/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp	(revision 18301)
@@ -25,4 +25,7 @@
 	femmodel->parameters->FindParam(&analysisenum,AnalysisTypeEnum);
 
+	/*Display message*/
+	if(VerboseModule()) _printf0_("   Updating inputs from solution\n");
+
 	Analysis* analysis = EnumToAnalysis(analysisenum);
 	for(int i=0;i<femmodel->elements->Size();i++){
Index: issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 18301)
@@ -75,4 +75,17 @@
 			}
 			EdgeOnBoundaryFlags(&boundaryedge,iomodel);
+			break;
+		case P2bubbleEnum:
+			EdgesPartitioning(&my_edges,iomodel);
+			if(iomodel->meshelementtype==PentaEnum){
+				FacesPartitioning(&my_faces,iomodel);
+			}
+			EdgeOnBoundaryFlags(&boundaryedge,iomodel);
+			switch(iomodel->meshelementtype){
+				case TriaEnum:  elementnbv = 3; break;
+				case TetraEnum: elementnbv = 4; break;
+				case PentaEnum: elementnbv = 6; break;
+				default: _error_("mesh type not supported yet");
+			}
 			break;
 		case P2xP4Enum:
@@ -138,4 +151,60 @@
 				}
 				break;
+			case P2bubbleEnum:
+				for(i=0;i<iomodel->numberofvertices;i++){
+					if((iomodel->my_vertices[i])){
+						if (!xIsNan<IssmDouble>(spcdata[i])){
+							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,dof,spcdata[i],analysis_type));
+							count++;
+						}
+					}
+				}
+				for(i=0;i<iomodel->numberofedges;i++){
+					if(my_edges[i] && boundaryedge[i]){
+						v1 = iomodel->edges[3*i+0]-1;
+						v2 = iomodel->edges[3*i+1]-1;
+						if(!xIsNan<IssmDouble>(spcdata[v1]) && !xIsNan<IssmDouble>(spcdata[v2])){
+							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+iomodel->numberofvertices+i+1,
+											dof,(spcdata[v1]+spcdata[v2])/2.,analysis_type));
+							count++;
+						}
+					}
+				}
+				if(iomodel->meshelementtype==PentaEnum){
+					for(i=0;i<iomodel->numberoffaces;i++){
+						if(iomodel->faces[i*iomodel->facescols+2]==2){/*Vertical quads*/
+							if(my_faces[i]){
+								numfacevertices = iomodel->faces[i*iomodel->facescols+3];
+								value=0.;
+								for(j=0;j<numfacevertices;j++){
+									value += spcdata[iomodel->faces[i*iomodel->facescols+4+j] -1];
+								}
+								value = value/reCast<IssmDouble>(numfacevertices);
+								if(!xIsNan<IssmDouble>(value)){
+									constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,
+													iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+i+1,
+													dof,value,analysis_type));
+									count++;
+								}
+							}
+						}
+					}
+				}
+				for(i=0;i<iomodel->numberofelements;i++){
+					if(iomodel->my_elements[i]){
+						value = spcdata[iomodel->elements[i*elementnbv+0]-1];
+						for(j=1;j<elementnbv;j++) value += spcdata[iomodel->elements[i*elementnbv+j]-1];
+						value = value/reCast<IssmDouble,int>(elementnbv+0);
+						if(!xIsNan<IssmDouble>(value)){
+							int nodeid = iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+i+1;
+							if(iomodel->meshelementtype==PentaEnum){
+								nodeid += iomodel->numberoffaces;
+							}
+							constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,nodeid,dof,value,analysis_type));
+							count++;
+						}
+					}
+				}
+				break;
 			case P2xP4Enum:
 				for(i=0;i<iomodel->numberofvertices;i++){
Index: issm/trunk/src/c/modules/Krigingx/Krigingx.cpp
===================================================================
--- issm/trunk/src/c/modules/Krigingx/Krigingx.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/Krigingx/Krigingx.cpp	(revision 18301)
@@ -11,6 +11,5 @@
 #include <gsl/gsl_linalg.h>
 #endif
-/*FUNCTION Krigingx{{{*/
-int Krigingx(double** ppredictions,double **perror,double* obs_x, double* obs_y, double* obs_list, int obs_length,double* x_interp,double* y_interp,int n_interp,Options* options){
+int   Krigingx(double** ppredictions,double **perror,double* obs_x, double* obs_y, double* obs_list, int obs_length,double* x_interp,double* y_interp,int n_interp,Options* options){/*{{{*/
 
 	/*output*/
@@ -189,6 +188,5 @@
 	return 1;
 }/*}}}*/
-/*FUNCTION Krigingxt{{{*/
-void* Krigingxt(void* vpthread_handle){
+void* Krigingxt(void* vpthread_handle){/*{{{*/
 
 	/*gate variables :*/
@@ -236,6 +234,5 @@
 	return NULL;
 }/*}}}*/
-/*FUNCTION NearestNeighbort{{{*/
-void* NearestNeighbort(void* vpthread_handle){
+void* NearestNeighbort(void* vpthread_handle){/*{{{*/
 
 	/*gate variables :*/
@@ -282,6 +279,5 @@
 	return NULL;
 }/*}}}*/
-/*FUNCTION idwt{{{*/
-void* idwt(void* vpthread_handle){
+void* idwt(void* vpthread_handle){/*{{{*/
 
 	/*gate variables :*/
@@ -328,6 +324,5 @@
 	return NULL;
 }/*}}}*/
-/*FUNCTION v4t{{{*/
-void* v4t(void* vpthread_handle){
+void* v4t(void* vpthread_handle){/*{{{*/
 
 	/*gate variables :*/
@@ -373,6 +368,5 @@
 	return NULL;
 }/*}}}*/
-/*FUNCTION Distancest{{{*/
-void* Distancest(void* vpthread_handle){
+void* Distancest(void* vpthread_handle){/*{{{*/
 
 	/*gate variables :*/
Index: issm/trunk/src/c/modules/Krigingx/Krigingx.h
===================================================================
--- issm/trunk/src/c/modules/Krigingx/Krigingx.h	(revision 18081)
+++ issm/trunk/src/c/modules/Krigingx/Krigingx.h	(revision 18301)
@@ -15,4 +15,5 @@
 int  pKrigingx(double** ppredictions,double **perror,double* x, double* y, double* observations, int n_obs,double* x_interp,double* y_interp,int n_interp,Options* options);
 void ProcessVariogram(Variogram **pvariogram,Options* options);
+void ProcessVariogram2(Variogram **pvariogram,Options* options);
 
 /*threading: */
Index: issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp
===================================================================
--- issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp	(revision 18301)
@@ -9,6 +9,5 @@
 #include "../../shared/io/io.h"
 
-/*FUNCTION pKrigingx{{{*/
-int pKrigingx(double** ppredictions,double **perror,double* obs_x, double* obs_y, double* obs_list, int obs_length,double* x_interp,double* y_interp,int n_interp,Options* options){
+int pKrigingx(double** ppredictions,double **perror,double* obs_x, double* obs_y, double* obs_list, int obs_length,double* x_interp,double* y_interp,int n_interp,Options* options){/*{{{*/
 
 #ifdef _HAVE_MPI_
@@ -66,5 +65,5 @@
 
 		/*Process Variogram*/
-		ProcessVariogram(&variogram,options);
+		ProcessVariogram2(&variogram,options);
 
 		/*partition loop across threads: */
@@ -157,5 +156,5 @@
 #endif
 }/*}}}*/
-void ProcessVariogram(Variogram **pvariogram,Options* options){/*{{{*/
+void ProcessVariogram2(Variogram **pvariogram,Options* options){/*{{{*/
 
 	/*Intermediaries*/
Index: issm/trunk/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 18301)
@@ -16,8 +16,8 @@
 	int         num_cm_responses;
 	int        *control_type     = NULL;
+	int        *maxiter          = NULL;
 	int        *cm_responses     = NULL;
 	IssmDouble *cm_jump          = NULL;
 	IssmDouble *optscal          = NULL;
-	IssmDouble *maxiter          = NULL;
 
 	/*retrieve some parameters: */
@@ -56,5 +56,5 @@
 				parameters->AddObject(new DoubleMatParam(InversionGradientScalingEnum,optscal,nsteps,num_control_type));
 				parameters->AddObject(new DoubleVecParam(InversionStepThresholdEnum,cm_jump,nsteps));
-				parameters->AddObject(new DoubleVecParam(InversionMaxiterPerStepEnum,maxiter,nsteps));
+				parameters->AddObject(new IntVecParam(InversionMaxiterPerStepEnum,maxiter,nsteps));
 				break;
 			case 1:/*TAO*/
@@ -74,4 +74,6 @@
 				parameters->AddObject(iomodel->CopyConstantObject(InversionMaxiterEnum));
 				break;
+			case 3:/*Validation*/
+				break;
 			default:
 				_error_("not supported");
@@ -81,7 +83,7 @@
 		xDelete<int>(control_type);
 		xDelete<int>(cm_responses);
+		xDelete<int>(maxiter);
 		iomodel->DeleteData(cm_jump,InversionStepThresholdEnum);
 		iomodel->DeleteData(optscal,InversionGradientScalingEnum);
-		iomodel->DeleteData(maxiter,InversionMaxiterPerStepEnum);
 	}
 }
Index: issm/trunk/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/ModelProcessorx/Control/UpdateElementsAndMaterialsControl.cpp	(revision 18301)
@@ -12,6 +12,5 @@
 
 	/*Intermediary*/
-	int       i;
-	int       counter;
+	int       control;
 	Element  *element = NULL;
 	Material *material = NULL;
@@ -33,6 +32,6 @@
 	iomodel->FetchData(5,InversionControlParametersEnum,InversionCostFunctionsEnum,InversionCostFunctionsCoefficientsEnum,InversionMinParametersEnum,InversionMaxParametersEnum);
 
-	for(i=0;i<num_control_type;i++){
-		int control = reCast<int,IssmDouble>(iomodel->Data(InversionControlParametersEnum)[i]);
+	for(int i=0;i<num_control_type;i++){
+		control = reCast<int,IssmDouble>(iomodel->Data(InversionControlParametersEnum)[i]);
 		switch(control){
 			/*List of supported controls*/
@@ -44,4 +43,5 @@
 			case BalancethicknessNuxEnum:
 			case BalancethicknessNuyEnum:
+			case BalancethicknessApparentMassbalanceEnum:
 				iomodel->FetchData(1,control); 
 				break;
@@ -56,6 +56,6 @@
 
 	/*Update elements: */
-	counter=0;
-	for (i=0;i<iomodel->numberofelements;i++){
+	int counter=0;
+	for(int i=0;i<iomodel->numberofelements;i++){
 		if(iomodel->my_elements[i]){
 			element=(Element*)elements->GetObjectByOffset(counter);
@@ -66,4 +66,14 @@
 
 	/*Free data: */
-	iomodel->DeleteData(5+7,InversionControlParametersEnum,InversionCostFunctionsCoefficientsEnum,InversionCostFunctionsEnum,InversionMinParametersEnum,InversionMaxParametersEnum,BalancethicknessThickeningRateEnum,VxEnum,VyEnum,ThicknessEnum,FrictionCoefficientEnum,MaterialsRheologyBEnum,DamageDEnum);
+	for(int i=0;i<num_control_type;i++){
+		control = reCast<int,IssmDouble>(iomodel->Data(InversionControlParametersEnum)[i]);
+		switch(control){
+			case MaterialsRheologyBbarEnum: iomodel->DeleteData(1,MaterialsRheologyBEnum); break;
+			case DamageDbarEnum:            iomodel->DeleteData(1,DamageDEnum);            break;
+			default:                        iomodel->DeleteData(1,control); 
+		}
+	}
+	iomodel->DeleteData(5,InversionControlParametersEnum,InversionCostFunctionsCoefficientsEnum,InversionCostFunctionsEnum,InversionMinParametersEnum,InversionMaxParametersEnum);
+
+
 }
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 18301)
@@ -56,8 +56,6 @@
 				case 2:
 					elements->InputDuplicate(MaterialsRheologyBEnum,MaterialsRheologyBbarEnum);
-					if(dakota_analysis) elements->InputDuplicate(MaterialsRheologyBbarEnum,QmuMaterialsRheologyBEnum);
 					break;
 				case 3:
-					if(dakota_analysis) elements->InputDuplicate(MaterialsRheologyBEnum,QmuMaterialsRheologyBEnum); 
 					break;
 				default:
@@ -74,8 +72,6 @@
 					elements->InputDuplicate(MaterialsRheologyBEnum,MaterialsRheologyBbarEnum);
 					elements->InputDuplicate(DamageDEnum,DamageDbarEnum);
-					if(dakota_analysis) elements->InputDuplicate(MaterialsRheologyBbarEnum,QmuMaterialsRheologyBEnum);
 					break;
 				case 3:
-					if(dakota_analysis) elements->InputDuplicate(MaterialsRheologyBEnum,QmuMaterialsRheologyBEnum); 
 					break;
 				default:
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateFaces.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateFaces.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateFaces.cpp	(revision 18301)
@@ -164,4 +164,5 @@
 			elementfaces_markers[1] = 1;
 			elementfaces_markers[2] = 1;
+			elementfaces_markers[3] = 1;
 			elementfaces[cols*0+0] = 3; elementfaces[cols*0+1] = 0;  elementfaces[cols*0+2] = 1; elementfaces[cols*0+3] = 2;
 			elementfaces[cols*1+0] = 3; elementfaces[cols*1+1] = 0;  elementfaces[cols*1+2] = 3; elementfaces[cols*1+3] = 1;
